import 'package:equatable/equatable.dart';
import 'package:flutter/material.dart';
import '../../colors.dart';

//enums for the case of wheather or not the letter is in the word. this dictates the color displayed
enum LetterStatus { initial, notInWord, inWord, correct}

/// class for a singular [Letter], this is one piece displayed on the gameboard
class Letter extends Equatable{
  const Letter({
    required this.val,
    this.status = LetterStatus.initial,
});
  factory Letter.empty() => const Letter(val: '');
  final String val;
  final LetterStatus status;

  Color get backgroundColor {
    switch (status) {
      case LetterStatus.initial:
        return Colors.transparent;
      case LetterStatus.notInWord:
        return morkBlaa;
      case LetterStatus.inWord:
        return gul;
      case LetterStatus.correct:
        return gronn;
    }
  }
  Color get borderColor {
   switch (status) {
     case LetterStatus.initial:
       return blaa;
     default:
       return Colors.transparent;
   }
  }

  Letter copyWith({
    String? val,
    LetterStatus? status,
}) {
    return Letter(
      val: val ?? this.val,
      status: status ?? this.status,
    );
  }

  @override
  List<Object?> get props => [val, status];
}